package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;

import java.util.Calendar;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.TimePickerDialog;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ListView;
import android.widget.TimePicker;

public class ConfigurarPorHoraActivity extends Activity {
	
	final String[] datos =
		    new String[]{"Hora de inicio", "Hora de fin", "Repetir"};
	
	Integer idPerfil;
	StringBuilder hora_guardar;
	String hora_inicio;
	String hora_fin;
	int posicion;
	String [] por_hora;
	
	private static final int DIALOGO_ALERTA_HORAS = 7;
	private Perfil perfil;
	
	CheckBox chkPorHora;
	ListView listaHoras;
	Button btnGuardarPorHora;
	
	/** Get the current time */
	final Calendar cal = Calendar.getInstance();
	
	//Dialogos de horas
    
	int pHourInicio;
    int pMinuteInicio;
    int pHourFin;
    int pMinuteFin;
    /** This integer will uniquely define the dialog to be used for displaying time picker.*/
    static final int TIME_DIALOG_INICIO_ID = 0;
    static final int TIME_DIALOG_FIN_ID = 8;
    
    /** Callback received when the user "picks" a time in the dialog */
    TimePickerDialog.OnTimeSetListener mTimeSetListenerInicio =
        new TimePickerDialog.OnTimeSetListener() {
            public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
            	pHourInicio = hourOfDay;
            	pMinuteInicio = minute;
            	
                hora_guardar = new StringBuilder().append(pad(pHourInicio)).append(":").append(pad(pMinuteInicio));
                
                hora_inicio = hora_guardar.toString();
            }
                
        };
        
        /** Callback received when the user "picks" a time in the dialog */
        TimePickerDialog.OnTimeSetListener mTimeSetListenerFin =
                new TimePickerDialog.OnTimeSetListener() {
                    public void onTimeSet(TimePicker view, int hourOfDay, int minute) {
                    	pHourFin = hourOfDay;
                    	pMinuteFin = minute;
                    	
                        hora_guardar = new StringBuilder().append(pad(pHourFin)).append(":").append(pad(pMinuteFin));
                        
                        hora_fin = hora_guardar.toString();
                    }
                        
                };
    /** Add padding to numbers less than ten */
    String pad(int c) {
        if (c >= 10)
            return String.valueOf(c);
        else
            return "0" + String.valueOf(c);
    }
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.configurarporhora);
        
        //Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        
        //Obtenemos los datos de Hora de la BD
        perfil = new Perfil();
    	perfil.loadPerfil(ConfigurarPorHoraActivity.this,idPerfil);
    	por_hora = perfil.buscarPorHora(this);
    	
    	if(por_hora[1] != null){
        	String [] split_hora_inicio = por_hora[1].split(":");
        	pHourInicio = Integer.parseInt(split_hora_inicio[0]);
        	pMinuteInicio = Integer.parseInt(split_hora_inicio[1]);
        }else{
        	pHourInicio = cal.get((Calendar.HOUR_OF_DAY));
            pMinuteInicio = cal.get((Calendar.MINUTE));
        }
    	
    	if(por_hora[2] != null){
        	String [] split_hora_fin = por_hora[2].split(":");
        	pHourFin = Integer.parseInt(split_hora_fin[0]);
        	pMinuteFin = Integer.parseInt(split_hora_fin[1]);
        }else{
        	pHourFin = cal.get((Calendar.HOUR_OF_DAY));
            pMinuteFin = cal.get((Calendar.MINUTE));
        }
    	
        //Checkbox Configurar por hora
        
        chkPorHora = (CheckBox)findViewById(R.id.ChkPorHora);
        
        //Lista de horas
        
        ArrayAdapter<String> adaptador =
    		    new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1, datos);
        
        listaHoras = (ListView)findViewById(R.id.ListaHoras);
    		 
        listaHoras.setAdapter(adaptador);
    		
        listaHoras.setOnItemClickListener(new OnItemClickListener() {
		    public void onItemClick(AdapterView<?> a, View v, int position, long id) {
		    	posicion = position;
		    	if(position == 0){	//Hora de inicio
		    		showDialog(TIME_DIALOG_INICIO_ID);
		    	}else if(position == 1){	//Hora de fin
		    		showDialog(TIME_DIALOG_FIN_ID);
		    	}else if(position == 2){//Repetir
		    		Intent intent = new Intent(ConfigurarPorHoraActivity.this, RepetirActivity.class);
		    		intent.putExtra("id", idPerfil);
		    		intent.putExtra("repetir", "hora");
		    		startActivity(intent);
		    	}
		    }
    	});
        
        if(Integer.parseInt(por_hora[0]) == 1){
        	chkPorHora.setChecked(true);
        	listaHoras.setEnabled(true);
        }else{
        	chkPorHora.setChecked(false);
        	listaHoras.setEnabled(false);
        }
        
        chkPorHora.setOnCheckedChangeListener(
            new CheckBox.OnCheckedChangeListener() {
                public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                    if (isChecked) {
                    	listaHoras.setEnabled(true);
                    }
                    else {
                    	listaHoras.setEnabled(false);
                }
            }
        });
        
        //Botn Guardar
        
        btnGuardarPorHora = (Button)findViewById(R.id.BtnGuardarPorHora);
        
        btnGuardarPorHora.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0)
            {
            	guardarPorHora(arg0);
            }
        });
    		
    }
    
    public void guardarPorHora(View v){
    	
    	perfil = new Perfil();
    	perfil.loadPerfil(ConfigurarPorHoraActivity.this,idPerfil);
    	
    	if(chkPorHora.isChecked()){
    		perfil.setPorHora(1);
    		if(hora_inicio == null || hora_fin == null){
    			showDialog(DIALOGO_ALERTA_HORAS);
    		}else{
				perfil.setHoraInicio(hora_inicio.toString());
				perfil.setHoraFin(hora_fin.toString());
    			finish();
    		}
    	}else{
    		perfil.setPorHora(0);
    		finish();
    	}
    	
    	perfil.updatePerfilPorHora(this);
    }
    
	/** Create a new dialog for time picker */
	
	@Override
	protected Dialog onCreateDialog(int id) {
	    switch (id) {
	    case TIME_DIALOG_INICIO_ID:
	    	return new TimePickerDialog(this,mTimeSetListenerInicio, pHourInicio, pMinuteInicio, true);
	    case TIME_DIALOG_FIN_ID:
	    	return new TimePickerDialog(this,mTimeSetListenerFin, pHourFin, pMinuteFin, true);
	    case DIALOGO_ALERTA_HORAS:
			return crearDialogoAlertaHoras();
	    }
	    return null;
	}
	
	 private Dialog crearDialogoAlertaHoras()
	    {
	        AlertDialog.Builder builder = new AlertDialog.Builder(this);
	     
	        builder.setTitle("Error");
	        builder.setMessage("Debe seleccionar una hora de inicio y de fin.");
	        builder.setPositiveButton("OK", new OnClickListener() {
	            public void onClick(DialogInterface dialog, int which) {
	                dialog.cancel();
	            }
	        });
	     
	        return builder.create();
	    }
}