package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import geo.profile.adapter.FilaEliminarPerfilListAdapter;
import geo.profile.data.PerfilSQLiteHelper;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.content.DialogInterface.OnClickListener;
import android.os.Bundle;
import android.view.View;
import android.widget.ListView;


public class EliminarPerfilActivity extends ListActivity {
	
	private PerfilSQLiteHelper bd;
	Integer idPerfil;
	String nombrePerfil;
	Perfil p;
	
	private static final int DIALOGO_ELIMINAR_PERFIL = 11;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.eliminarperfil);
        
        bd = new PerfilSQLiteHelper(EliminarPerfilActivity.this, "DBPerfil", null, 1);
        
        //Aadimos el listado de perfiles
        setListAdapter(new FilaEliminarPerfilListAdapter(EliminarPerfilActivity.this, bd.listPerfiles(10000)));
    }
    
    @Override
	protected void onResume() {
        super.onResume();  
        if(bd.listPerfiles(10)!= null){
        	setListAdapter(new FilaEliminarPerfilListAdapter(EliminarPerfilActivity.this, bd.listPerfiles(10000)));
        }
     }
    
    @Override
    protected void onListItemClick(ListView l, View v, int position, long id) {
    	// TODO Auto-generated method stub
    	super.onListItemClick(l, v, position, id);
    	
    	String[] perfil = (String[]) l.getItemAtPosition(position);
    	
    	idPerfil = Integer.parseInt(perfil [0]);
    	nombrePerfil = perfil[1];
    	
    	p = new Perfil();
    	p.loadPerfil(getApplicationContext(), idPerfil);
    	
    	showDialog(DIALOGO_ELIMINAR_PERFIL);
    	
    }
    
    @Override
	protected Dialog onCreateDialog(int id) {
	    switch (id) {
	    case DIALOGO_ELIMINAR_PERFIL:
			return crearDialogoEliminarPerfil();
	    }
	    return null;
	}
    
    private Dialog crearDialogoEliminarPerfil()
    {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
     
        builder.setTitle("Eliminar Perfil");
        builder.setMessage("Est seguro de que desea eliminar el perfil " +nombrePerfil+ "? " +
        		"Si lo elimina no podr volver a recuperarlo.");
        builder.setPositiveButton("Eliminar", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
            	p.deletePerfil(getApplicationContext(), idPerfil);
            	
            	if(bd.listPerfiles(10)!= null){
                	setListAdapter(new FilaEliminarPerfilListAdapter(EliminarPerfilActivity.this, bd.listPerfiles(10000)));
                }
            }
        });
        
        builder.setNegativeButton("Cancelar", new OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                dialog.cancel();
            }
        });
     
        return builder.create();
    }

}