package geo.profile.view;

import geo.profile.Perfil;
import geo.profile.R;
import android.app.Activity;
import android.content.Context;
import android.media.AudioManager;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;


public class SonidoActivity extends Activity {
	
	Integer idPerfil;
	CheckBox chkVibrador;
	Button btnGuardarSonido;
	
	//Declaramos las variables necesarias para gestionar el volumen
	private SeekBar seekBarVolumen;
	private AudioManager amanager;
	
	Perfil perfil;
	String [] sonido;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sonido);
        
        //Obtenemos el id (extra en el intent)
        Bundle bun = this.getIntent().getExtras();
        idPerfil = bun.getInt("id");
        
      //Obtenemos los datos de Sonido de la BD
        perfil = new Perfil();
    	perfil.loadPerfil(SonidoActivity.this,idPerfil);
    	sonido = perfil.buscarSonido(this);
    	
        //Checkbox Vibrador
        
        chkVibrador = (CheckBox)findViewById(R.id.ChkVibrador);
        
        //Tomamos el seek bar del XML
        seekBarVolumen = (SeekBar) findViewById(R.id.SeekBarVolumen);
        
        //Obtenemos el AudioManager
        amanager = (AudioManager) this.getSystemService(Context.AUDIO_SERVICE); 
        
        //Ajustes del seek bar
        //Ponemos el rango entre 0 y el maximo volumen
        seekBarVolumen.setMax(amanager.getStreamMaxVolume(AudioManager.STREAM_RING));
        //Ponemos el incremento en 1
        seekBarVolumen.setKeyProgressIncrement(1);
        
        //Ponemos el progreso del seek bar basado en el sistema de volumen
        seekBarVolumen.setProgress(Integer.parseInt(sonido[1]));
        
        //Registramos el Listener
        seekBarVolumen.setOnSeekBarChangeListener(new OnSeekBarChangeListener() 
  		{
  			public void onStopTrackingTouch(SeekBar seekBar) 
  			{	
  			}
  			
  			public void onStartTrackingTouch(SeekBar seekBar) 
  			{
  			}
  			
  			public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) 
  			{
  			}
  		});
        
        //Checkbox vibrador limita el volumen a 0
        
        chkVibrador.setOnCheckedChangeListener(
    	        new CheckBox.OnCheckedChangeListener() {
    	            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
    	                if (isChecked) {
    	                	seekBarVolumen.setEnabled(false);
    	                }
    	                else {
    	                	seekBarVolumen.setEnabled(true);
    		            }
    		        }
    		    });
        
        if(Integer.parseInt(sonido[0]) == 1){	//Vibrador
        	chkVibrador.setChecked(true);
        }else{
        	chkVibrador.setChecked(false);	//No vibrador
        }
        
        //Botn Guardar
        
        final Button btnGuardarSonido = (Button)findViewById(R.id.BtnGuardarSonido);
        
        btnGuardarSonido.setOnClickListener(new View.OnClickListener() {
            public void onClick(View arg0)
            {
            	guardarSonido(arg0);
            }
        });
        
        

    }
    
    public void guardarSonido(View v){
    	
    	perfil = new Perfil();
    	perfil.loadPerfil(SonidoActivity.this,idPerfil);
    	
    	perfil.setVolumen(seekBarVolumen.getProgress());
    	//El tono de llamada no est inlcuido en la primera version pero la BD est preparada
//		perfil.setTonoLlamada(tono_llamada);
    	
    	if(chkVibrador.isChecked()){
    		perfil.setVibrador(1);
    	}else{
    		perfil.setVibrador(0);
    	}
    	
    	finish();
    	
    	perfil.updatePerfilSonido(this);
    }
    
//    //Teclas de volumen
//    
//    @Override
//	public boolean onKeyDown(int keyCode, KeyEvent event) 
//	{
//		//if one of the volume keys were pressed
//		if(keyCode == KeyEvent.KEYCODE_VOLUME_DOWN || keyCode == KeyEvent.KEYCODE_VOLUME_UP)
//		{
//			//change the seek bar progress indicator position
//			seekBarVolumen.setProgress(amanager.getStreamVolume(AudioManager.STREAM_RING));
//		}
//		//propagate the key event
//		return super.onKeyDown(keyCode, event);
//	}
}